/**
 * Created by FMG on 2016/10/30.
 */
define(['app'], function(app) {
  'use strict';
  function ctrl($scope,$http,$ionicLoading,$translate,$ionicPopup,$timeout,$state,storage,$ionicListDelegate) {
    $scope.$on('$ionicView.enter',function(){
      myObj.webViewDidFinishLoad();
    });
    $scope.$on('$ionicView.beforeEnter',function(){
      $scope.getFriend();
    });
    $scope.$on('$ionicView.loaded',function(){
      myObj.showLoading();
      $scope.refreshList();
    });

    var result = myObj.getMessage();
    var user = JSON.parse(result);
    var lang = "";
    if (user.lngType != "undefined" && "ch" == user.lngType  ) {
    lang = "friend-zh";
    } else {
      lang = "friend-en";
    }
    $translate.use(lang);

    APIURL = storage.get('isTest') == 0 || typeof(storage.get('isTest')) == "undefined" ? formalUrl_https:testUrl_https ;

    // web
    //var userToken = "4227f968-1b29-4573-a8f0-8a7a018cc7f2-241";

    $scope.isEdit = false;
    $scope.backNative = function () {
      myObj.onBackClick();
    }
    $scope.editImg = 'edit';
    $scope.editClick = function () {
      console.log('edit');
      $scope.isEdit = !$scope.isEdit;
      $scope.editImg = $scope.isEdit ?'cancel':'edit';

      if(!$scope.isEdit){
        for (var i = 0; i < $scope.dataArr.length; i++) {
          if ($scope.dataArr[i].checked) {
            $scope.dataArr[i].checked = false;
          }
        }
      }
    }
    $scope.selectButton = function (userInfo) {
      userInfo.checked = !userInfo.checked;
    }
    $scope.dataArr = new Array();

      $scope.changeData = function (response) {
      $scope.dataArr = [];
      for (var i = 0; i < response.length; i++) {
        var userInfo = {
          account: response[i].accountNum,
          nickName: response[i].friendMark,
          isDeal: response[i].isDeal,
          userId: response[i].userID,
          imageUrl: response[i].imageUrl,
          checked: false
        }
        $scope.dataArr.push(userInfo);
        console.log($scope.dataArr);
      }
    }

    function dealHeader(url){
      var headersJson=myObj.getHeadersWithApi('/ppstrongs/'+url);
      var headers=JSON.parse(headersJson);
      $scope.authHeader = {
        'Content-Type': 'application/x-www-form-urlencoded',
        'X-Ca-Key':  headers.X_Ca_Key,
        'X-Ca-Sign':  headers.X_Ca_Sign,
        'X-Ca-Timestamp':  headers.X_Ca_Timestamp,
        'X-Ca-Nonce':  headers.X_Ca_Nonce
      }
    }
    function testAccount(account){
      var regPhone = /(^0{0,1}1[3|4|5|6|7|8|9][0-9]{9}$)/;
      var regEmail = /^[_\.0-9a-zA-Z-]+@([0-9a-zA-Z][0-9a-zA-Z-]+\.){1,4}[a-zA-Z]{2,3}$/
      if(!regPhone.test(account) && !regEmail.test(account)) {
        onlyShowPop('ACCOUNT_ILLEGAL');
        return false;
      }
      return true;
    }

    // 下拉刷新
    $scope.refreshList = function () {
      $scope.getFriend();
      $scope.$broadcast('scroll.refreshComplete');
    }

    // 获取好友列表
    $scope.getFriend = function(){
      var param = {
        userID:user.userID,
        userToken:user.userToken,
        phoneType:user.phoneType,
        lngType:user.lngType,
        sourceApp:SourceApp
      }
      dealHeader('initFriend.action');
      $http({
        method: 'post',
        url: APIURL + 'initFriend.action',
        data:param,
        headers: $scope.authHeader,
        transformRequest: function (obj) {
          var str = [];
          for (var p in obj) {
            str.push(encodeURIComponent(p) + "=" + encodeURIComponent(obj[p]));
          }
          return str.join("&");
        }
      }).success(function (data, status, headers, config) {
        if (data.resultCode == "1001") {
          myObj.hideLoading();
          //保存登录信息，并跳转到camera
          $scope.changeData(data.result);
        } else if (data.resultCode == "1023") {
          myObj.showRepeatLogin();
        } else {
          myObj.error(angular.toJson(data));
        }
      }).error(function (data, status) {
        myObj.networkError();
      })
    }


    // 添加好友
    $scope.addFriendAccount = '';
    $scope.search = function () {
      if(!$scope.addFriendAccount.length) return;
      if(!testAccount($scope.addFriendAccount)) return;

      var param = {
        userID: user.userID,
        accountNumFriend: $scope.addFriendAccount,
        userToken: user.userToken,
        phoneType: user.phoneType,
        lngType: user.lngType,
        sourceApp: SourceApp
      }
      dealHeader('insertFriend.action');
      myObj.showLoading();
      $http({
        method: 'post',
        url: APIURL + 'insertFriend.action',
        data:param,
        headers: $scope.authHeader,
        transformRequest: function (obj) {
          var str = [];
          for (var p in obj) {
            str.push(encodeURIComponent(p) + "=" + encodeURIComponent(obj[p]));
          }
          return str.join("&");
        }
      }).success(function (data, status, headers, config) {
        console.log(data);

        if (data.resultCode == "1011") {
          myObj.hideLoading();
          onlyShowPop('networkWaitDealing');
        } else if(data.resultCode == "1010"){
          myObj.hideLoading();
          onlyShowPop('networkIsFriends');
        } else if(data.resultCode == "1022"){
          myObj.hideLoading();
          onlyShowPop('networkNotAddSelf');
        } else if(data.resultCode == "1018"){
          myObj.hideLoading();
          onlyShowPop('networkAccountNotExist');
        } else if(data.resultCode == "1007"){
          myObj.hideLoading();
          onlyShowPop('networkAccountNotExist');
        } else if (data.resultCode == "1023") {
          myObj.showRepeatLogin();
        } else {
          myObj.error(angular.toJson(data));
        }
      }).error(function (data, status) {
        console.log(status);
        myObj.networkError();
      })

    }
    $scope.deleteFriendPop = function($index){
      var userIdsArr = [];
      console.log('index' + $index);
      if(typeof($index) != "undefined"){
        userIdsArr.push($scope.dataArr[$index].userId);
      } else {
        for (var i = 0; i < $scope.dataArr.length; i++) {
          if ($scope.dataArr[i].checked) {
            userIdsArr.push($scope.dataArr[i].userId);
          }
        }
      }
      if (userIdsArr.length){
        $scope.accountStr = JSON.stringify(userIdsArr)
      } else {
        var showTitle = $translate.instant('ON_SELECTED');
        myObj.showStatus(showTitle);
        return;
      }

      var title = $translate.instant('DEL_FRIEND_POP_TITLE');
      var ok = $translate.instant('OK');
      var cancel = $translate.instant('CANCEL');
      $ionicPopup.confirm({
        title: title,
        template:'<label style="text-align:center;width: 100%;display:inline-block;color: #9a9a9a;vertical-align: top" translate="DEL_FRIEND_POP_TEMP"></label>',
        cancelType: 'button-cancel',
        cancelText:cancel,
        okType: 'button-ok',
        okText: ok,
      }).then(function (res) {
        if (res) {
          $scope.deleteFriend($index);
        } else {
          $ionicListDelegate.closeOptionButtons();
          console.log('取消');
        }
      });
    };
    // 删除好友
    $scope.deleteFriend = function ($index) {
      myObj.showLoading();
      var param = {
        userID: user.userID,
        userIDSAll: $scope.accountStr,
        userToken: user.userToken,
        phoneType: user.phoneType,
        lngType: user.lngType,
        sourceApp: SourceApp
      }
      dealHeader('deleteMoreFriend.action');
      $http({
        method: 'post',
        url: APIURL + 'deleteMoreFriend.action',
        data:param,
        headers: $scope.authHeader,
        transformRequest: function (obj) {
          var str = [];
          for (var p in obj) {
            str.push(encodeURIComponent(p) + "=" + encodeURIComponent(obj[p]));
          }
          return str.join("&");
        }
      }).success(function (data, status, headers, config) {
        console.log(data);

        if (data.resultCode == "1001") {
          if(typeof($index) != "undefined"){
            $scope.dataArr.splice($index,1);
          } else {
            $scope.getFriend();
          }
          $scope.isEdit = false;
          $scope.editImg = 'edit';
        } else if (data.resultCode == "1023") {
          myObj.showRepeatLogin();
        } else {
          myObj.error(angular.toJson(data));
        }
        myObj.hideLoading();
      }).error(function (data, status) {
        myObj.hideLoading();
        console.log(status);
        myObj.networkError();

      })
    }
    $scope.didSelectRow = function(userInfo){
      $ionicListDelegate.closeOptionButtons();
      var infoStr = JSON.stringify(userInfo);
      $state.go('sharecamera',{params:infoStr});
    }
    function onlyShowPop(title){
      $scope.showTitle =title;
      $timeout(function(){
        $scope.showTitle = '';
      },2000);
    }
  }
  ctrl.$inject = ['$scope','$http','$ionicLoading','$translate','$ionicPopup','$timeout','$state','storage','$ionicListDelegate'];
  app.registerController('friendCtrl',ctrl);
})
