/**
 * Created by FMG on 2016/10/30.
 */
define(['app'], function(app) {
  'use strict';
  function ctrl($scope,$translate,$stateParams,$http,$ionicLoading,$timeout){
    $scope.$on('$ionicView.loaded', function () {
      myObj.showLoading();
      $scope.getDeviceList();
    });
    var result = myObj.getMessage();
    var user = JSON.parse(result);
    var lang = "";
    if (user.lngType != "undefined" &&"ch" == user.lngType) {
      lang = "friend-zh";
    } else {
      lang = "friend-en";
    }
    $translate.use(lang);
    // web
    //var userToken = "4227f968-1b29-4573-a8f0-8a7a018cc7f2-241";

    var userInfo = JSON.parse($stateParams.params);
    $scope.user = {
      nickName : userInfo.nickName,
      userId : userInfo.userId,
      account: userInfo.account
    }
    $scope.selectImg = 'normal';
    $scope.$watch('user.nickName', function(newVal,oldVal){
        $scope.isChange = newVal != oldVal;
      }, true
    );
    function changeData(data) {
      $scope.devicesArr = [];
      var rows = Math.ceil(data.length/2);
      var cols = data.length%2;
      for(var j=0; j<rows; j++){
        var devices = [];
        if(data.length -((j+1)*2)>=0){
          cols = 2;
        } else {
          cols = 1;
        }
        for (var i = 0; i < cols; i++) {
          devices.push(data[i + j*2]);
        }
        $scope.devicesArr.push(devices);
      }
      console.log('处理后数据'+$scope.devicesArr);
    }

    function dealHeader(url){
      var headersJson=myObj.getHeadersWithApi('/ppstrongs/'+url);
      var headers=JSON.parse(headersJson);
      $scope.authHeader = {
        'Content-Type': 'application/x-www-form-urlencoded',
        'X-Ca-Key':  headers.X_Ca_Key,
        'X-Ca-Sign':  headers.X_Ca_Sign,
        'X-Ca-Timestamp':  headers.X_Ca_Timestamp,
        'X-Ca-Nonce':  headers.X_Ca_Nonce
      }
    }
    // 下拉刷新
    $scope.refreshList = function () {
      $scope.getDeviceList();
      $scope.$broadcast('scroll.refreshComplete');
    }
    // 获取设备列表
    $scope.getDeviceList = function() {

      var param = {
        userID: user.userID,
        userIDS: userInfo.userId,
        userToken: user.userToken,
        phoneType: user.phoneType,
        lngType: user.lngType,
        sourceApp: SourceApp
      }
      dealHeader('initDetailFriend.action')
      $http({
        method: 'post',
        url: APIURL + 'initDetailFriend.action',
        data: param,
        headers: $scope.authHeader,
        transformRequest: function (obj) {
          var str = [];
          for (var p in obj) {
            str.push(encodeURIComponent(p) + "=" + encodeURIComponent(obj[p]));
          }
          return str.join("&");
        }
      }).success(function (data, status, headers, config) {
        console.log(data);
        if (data.resultCode == "1001") {
          myObj.hideLoading();
          changeData(data.result);
        } else if (data.resultCode == "1023") {
          myObj.showRepeatLogin();
        } else {
          myObj.error(angular.toJson(data));
        }
      }).error(function (data, status) {
        console.log(status);
        myObj.networkError();
      })
    }
    // 分享/取消分享设备
    $scope.shareDevice = function(device){
      var subUrl= device.share ? 'cancelFriendDevice.action':'shareFriendDevice.action';
      var param = {
        userID: user.userID,
        userIDS: userInfo.userId,
        deviceID: device.deviceID,
        deviceUUID: device.deviceUUID,
        userToken: user.userToken,
        phoneType: user.phoneType,
        lngType: user.lngType,
        sourceApp: SourceApp
      }
      dealHeader(subUrl);
      $http({
        method: 'post',
        url: APIURL + subUrl,
        data:param,
        headers: $scope.authHeader,
        transformRequest: function (obj) {
          var str = [];
          for (var p in obj) {
            str.push(encodeURIComponent(p) + "=" + encodeURIComponent(obj[p]));
          }
          return str.join("&");
        }
      }).success(function (data, status, headers, config) {
        console.log(data);
        if (data.resultCode == "1001") {
          device.share = !device.share;
          $scope.selectImg = device.share?'select':'normal';
          console.log('结果' + data.result);
        } else if (data.resultCode == "1023") {
          myObj.showRepeatLogin();
        } else {
          myObj.error(angular.toJson(data));
        }
      }).error(function (data, status) {
        console.log(status);
        myObj.networkError();
      })
    }
    function onlyShowPop(title){
      var showTitle = $translate.instant(title);
      myObj.showStatus(showTitle);
    }

    // 修改别名
    $scope.changeNickName = function () {
      if (userInfo.nickName == $scope.user.nickName) {
        $scope.isChange = false;
        return;
      }
      if($scope.user.nickName.length == 0){
        onlyShowPop('REMARK_NOT_NULL');
        return;
      }
      var param = {
        userID: user.userID,
        userIDS: userInfo.userId,
        friendRemark: $scope.user.nickName,
        userToken: user.userToken,
        phoneType: user.phoneType,
        lngType: user.lngType,
        sourceApp: SourceApp
      }
      dealHeader('updateFriendMark.action');
      myObj.showLoading();
      $http({
        method: 'post',
        url: APIURL + 'updateFriendMark.action',
        data:param,
        headers: $scope.authHeader,
        transformRequest: function (obj) {
          var str = [];
          for (var p in obj) {
            str.push(encodeURIComponent(p) + "=" + encodeURIComponent(obj[p]));
          }
          return str.join("&");
        }
      }).success(function (data, status, headers, config) {
        console.log(data);
        if (data.resultCode == "1001") {
          myObj.hideLoading();
          $scope.isChange = false;
        } else if (data.resultCode == "1023") {
          myObj.showRepeatLogin();
        } else {
          myObj.error(angular.toJson(data));
        }
      }).error(function (data, status) {
        console.log(status);
        myObj.networkError();
      })
    }

  }
  ctrl.$inject = ['$scope','$translate','$stateParams','$http','$ionicLoading','$timeout'];
  app.registerController('shareCameraCtrl',ctrl);
})

