
define(['app'], function (app) {
  'use strict';
  function ctrl($scope,$http,$ionicLoading,$interval,$translate,$timeout,storage,$stateParams) {

    var result = myObj.getMessage();
    var userInfo = JSON.parse(result);
    var lang = "";
    if ("ch" == userInfo.lngType) {
      lang = "login-zh";
    } else {
      lang = "login-en";
    }
    $translate.use(lang);

    // web
    //var userToken = "123";

    $scope.user = {
      account: $stateParams.params,
      password:'',
      verCode:'',
      rePassword:''
    }
    $scope.buttonDisabled =false;

    $scope.showPassword = function() {
      $scope.showPsd = !$scope.showPsd;
    }

    function dealHeader(url){
      var headersJson=myObj.getHeadersWithApi('/ppstrongs/'+url);
      var headers=JSON.parse(headersJson);
      $scope.authHeader = {
        'Content-Type': 'application/x-www-form-urlencoded',
        'X-Ca-Key':  headers.X_Ca_Key,
        'X-Ca-Sign':  headers.X_Ca_Sign,
        'X-Ca-Timestamp':  headers.X_Ca_Timestamp,
        'X-Ca-Nonce':  headers.X_Ca_Nonce
      }
    }
    function onlyShowPop(title){
      var showTitle = $translate.instant(title);
      myObj.showStatus(showTitle);
    }
    function testAccount(account){
      var regPhone = /(^0{0,1}1[3|4|5|6|7|8|9][0-9]{9}$)/;
      var regEmail = /^[_\.0-9a-zA-Z-]+@([0-9a-zA-Z][0-9a-zA-Z-]+\.){1,4}[a-zA-Z]{2,3}$/
      if(!regPhone.test(account) && !regEmail.test(account)) {
        onlyShowPop('ACCOUNT_ILLEGAL');
        return false;
      }
      return true;
    }

    $scope.getVerCode = function(){
      if ($scope.user.account == '') {
        onlyShowPop('ACCOUNT_NULL');
        return;
      }
      if(!testAccount($scope.user.account)) return;
      // native
      var param = {
        userAccount:$scope.user.account,
        userToken:userInfo.userToken,
        phoneType:userInfo.phoneType,
        lngType:userInfo.lngType,
        sourceApp:SourceApp
      }
      myObj.showLoading();
      dealHeader('getEmailVerifaction.action');
      //ajax请求
      $http({
        method: 'post',
        url: APIURL + 'getEmailVerifaction.action',
        data:param,
        headers: $scope.authHeader,
        transformRequest: function (obj) {
          var str = [];
          for (var p in obj) {
            str.push(encodeURIComponent(p) + "=" + encodeURIComponent(obj[p]));
          }
          return str.join("&");
        }
      }).success(function (data, status, headers, config) {
        if (data.resultCode == "1001") {
          myObj.hideLoading();
          $scope.secondTimer(data.eTime);
        } else if (data.resultCode == "1004") {
          onlyShowPop('VERCODE_SENDED');
          $scope.secondTimer(data.leastTime);
        } else {
          myObj.error(angular.toJson(data));
        }
      }).error(function (data, status) {
        myObj.networkError();
      })
    }

    $scope.secondTimer = function(num){
        if(!num || num == "undefined")return;
        var iNow = num;
        $scope.buttonDisabled =true;
        $scope.time=iNow;
        var timer = $interval(function(){
          $scope.time = iNow--;
          if (iNow == 0){
            $interval.cancel(timer);
            $scope.buttonDisabled = false;
          }
        },1000)
    }

    $scope.resetPassword = function(){
      if ($scope.user.account == '') {
        onlyShowPop('ACCOUNT_NULL');
        return;
      }
      if ($scope.user.verCode == '') {
        onlyShowPop('CODE_NOT_NULL');
        return;
      }
      if ($scope.user.password == '' || $scope.user.rePassword == '') {
        onlyShowPop('PSW_NULL');
        return;
      }
      if ($scope.user.password.length < 6 || $scope.user.password.length > 20) {
        onlyShowPop('PSW_LENGTH_ERROR');
        return;
      }
      if ($scope.user.password != $scope.user.rePassword) {
        onlyShowPop('PSW_NOT_SAME');
        return;
      }
      if(!testAccount($scope.user.account)) return;
      var desPsw = myObj.DESEncrypt($scope.user.password);
      myObj.showLoading();
      // native
      var param = {
        UserAccount:$scope.user.account,
        password:desPsw,
        verificationCode:$scope.user.verCode,
        userToken:userInfo.userToken,
        phoneType:userInfo.phoneType,
        lngType:userInfo.lngType,
        sourceApp:SourceApp
      }
      dealHeader('updatePassword.action');
      $http({
        method: 'post',
        url: APIURL + 'updatePassword.action',
        data:param,
        headers: $scope.authHeader,
        transformRequest: function (obj) {
          var str = [];
          for (var p in obj) {
            str.push(encodeURIComponent(p) + "=" + encodeURIComponent(obj[p]));
          }
          return str.join("&");
        }
      }).success(function (data, status, headers, config) {
        if (data.resultCode == "1001") {
          myObj.hideLoading();
          saveAccount($scope.user.account);
          // 保存登录信息，并跳转到camera
          myObj.gotoDestCtrl(angular.toJson(data));
        } else {
          myObj.error(angular.toJson(data));
        }
      }).error(function (data, status) {
        myObj.networkError();
      })
    }
    function saveAccount(account){
      var accountJSON = storage.get('account');
      if (typeof(accountJSON)== "undefined") {
        var accountArr = new Array();
      } else {
        var accountArr = JSON.parse(accountJSON);
      }
      if(accountArr.indexOf(account) <= -1) {
        accountArr.push(account);
        var accountStr = JSON.stringify(accountArr);
        storage.set('account',accountStr);

      } else {
        var index = accountArr.indexOf(account);
        if(index == accountArr.length -1) {
          return;
        }
        accountArr.splice(index,1);
        accountArr.push(account);
        var accountStr = JSON.stringify(accountArr);
        storage.set('account',accountStr);
      }
    }
  }
    ctrl.$inject = ['$scope','$http','$ionicLoading','$interval','$translate','$timeout','storage','$stateParams'];
    app.registerController('findpswCtrl',ctrl);
});
