/**
 * Created by PPStrong on 16/11/17.
 */
define(['app'], function(app) {
  'use strict';
  function ctrl($scope, storage, $http, $translate,$timeout,$ionicHistory) {
    var result = myObj.getMessage();
    var user = JSON.parse(result);
    var wordLimit = '';
    var lang = "";
    if (user.lngType != "undefined" &&"ch" == user.lngType) {
      lang = "more-zh";
      wordLimit = 256;
    } else {
      lang = "more-en";
      wordLimit = 256 * 3;
    }
    $translate.use(lang);
    $scope.suggest = {
      message : '',
      limit: wordLimit
    }
    $scope.submitImg = '';
    $scope.$watch('suggest.message', function(){
      $scope.submitImg = $scope.suggest.message.length >0 ? '_ok':'';
    },true)
    $scope.showPop = function(title){
      var showTitle = $translate.instant(title);
      myObj.showStatus(showTitle);
      $timeout(function(){
        $ionicHistory.goBack();
      },1000);
    }
    function dealHeader(url){
      var headersJson=myObj.getHeadersWithApi('/ppstrongs/'+url);
      var headers=JSON.parse(headersJson);
      $scope.authHeader = {
        'Content-Type': 'application/x-www-form-urlencoded',
        'X-Ca-Key':  headers.X_Ca_Key,
        'X-Ca-Sign':  headers.X_Ca_Sign,
        'X-Ca-Timestamp':  headers.X_Ca_Timestamp,
        'X-Ca-Nonce':  headers.X_Ca_Nonce
      }
    }
      $scope.submitMessage = function(){
        if(!$scope.suggest.message.length) return;
        var param = {
          userID: user.userID,
          content: $scope.suggest.message,
          userToken: user.userToken,
          phoneType: user.phoneType,
          lngType: user.lngType,
          sourceApp: SourceApp
        }
        dealHeader('feedBack.action');
        myObj.showLoading();
        $http({
          method: 'post',
          url: APIURL + 'feedBack.action',
          data:param,
          headers: $scope.authHeader,
          transformRequest: function (obj) {
            var str = [];
            for (var p in obj) {
              str.push(encodeURIComponent(p) + "=" + encodeURIComponent(obj[p]));
            }
            return str.join("&");
          }
        }).success(function (data, status, headers, config) {
          if ("1001" == data.resultCode) {
            $scope.showPop('FEEDBACK_SUCCESS');
          } else if (data.resultCode == "1023") {
            myObj.showRepeatLogin();
          } else {
            myObj.error(angular.toJson(data));
          }
        }).error(function (data, status) {
          myObj.networkError();
        })

    }
  }
  ctrl.$inject = ['$scope', 'storage', '$http', '$translate','$timeout','$ionicHistory'];
  app.registerController('moreFeedbackCtrl', ctrl);
});
