/**
 * Created by PPStrong on 16/11/17.
 */
define(['app'], function(app) {
  'use strict';
  function ctrl($scope,storage,$http,$translate,$state) {
    $scope.$on('$ionicView.enter',function(){
      myObj.webViewDidFinishLoad();
    });
    $scope.$on('$ionicView.loaded',function(){
      localSoundFlag();
    });
    var result = myObj.getMessage();
    var user = JSON.parse(result);
    var lang = "";
    if ("ch" == user.lngType) {
    lang = "more-zh";
    } else {
      lang = "more-en";
    }
    $translate.use(lang);
    APIURL = storage.get('isTest') == 0 || typeof(storage.get('isTest')) == "undefined" ?  formalUrl_https:testUrl_https;

    // native
    $scope.appVersion = user.versionName;

    //$scope.appVersion = '2.0';

    $scope.platformType = user.phoneType;
    $scope.shouldUpdate = user.versionStatus;

    function localSoundFlag (){
      var soundFlag = storage.get('soundFlag');
      console.log('FF'+soundFlag);
      $scope.sound = {
        isOpen:soundFlag == 0 ? true : false
      }
    }
    $scope.$watch('sound.isOpen', function(newVal,oldVal){
      console.log('new:'+ newVal);
        console.log('old:'+ oldVal);
        if(newVal != oldVal){
          var flag = newVal == true ? 0:1;
          soundClick(flag);
        }
      }, true
    )

    function dealHeader(url){
      var headersJson=myObj.getHeadersWithApi('/ppstrongs/'+url);
      var headers=JSON.parse(headersJson);
      $scope.authHeader = {
        'Content-Type': 'application/x-www-form-urlencoded',
        'X-Ca-Key':  headers.X_Ca_Key,
        'X-Ca-Sign':  headers.X_Ca_Sign,
        'X-Ca-Timestamp':  headers.X_Ca_Timestamp,
        'X-Ca-Nonce':  headers.X_Ca_Nonce
      }
    }

    function soundClick(flag){

      var param = {
        userID: user.userID,
        soundFlag: flag,
        userToken: user.userToken,
        phoneType: user.phoneType,
        lngType: user.lngType,
        sourceApp: SourceApp
      }
      dealHeader('updateSoundFlag.action');
      $http({
        method: 'post',
        url: APIURL + 'updateSoundFlag.action',
        data:param,
        headers: $scope.authHeader,
        transformRequest: function (obj) {
          var str = [];
          for (var p in obj) {
            str.push(encodeURIComponent(p) + "=" + encodeURIComponent(obj[p]));
          }
          return str.join("&");
        }
      }).success(function (data, status, headers, config) {
        console.log(data);
        if ("1001" == data.resultCode) {
          storage.set('soundFlag',data.soundFlag);
          myObj.soundActionStatus(data.soundFlag);
        } else if (data.resultCode == "1023") {
          localSoundFlag();
          myObj.showRepeatLogin();
        } else {
          localSoundFlag();
          myObj.error(angular.toJson(data));
        }
      }).error(function (data, status) {
        console.log(status);
        myObj.networkError();
      })
    };

    $scope.selectItem = function(num){
      switch (num) {
        case 1: {
          myObj.openAlbum();
          //$state.go('morePicVideo');
          break;
        }
        case 2: {
          if ($scope.platformType == 'i') {
            myObj.openAppStore();
          } else {
            myObj.checkVersion();
          }
          break;
        }
        case 3: {
          $state.go('moreFeedback');
          break;
        }
        case 4: {
          $state.go('moreAbout');
          break;
        }
      }
    }
    $scope.backNative = function () {
      myObj.onBackClick();
    }

  }
  ctrl.$inject = ['$scope','storage','$http','$translate','$state'];
  app.registerController('moreHomeCtrl',ctrl);
});
