/**
 * Created by PPStrong on 16/11/15.
 */
define(['app'], function(app) {
  'use strict';
  function ctrl($scope, $http, $ionicLoading, $translate) {
    $scope.$on('$ionicView.loaded', function(){
      $scope.getOrderList();
    })
    var result = myObj.getMessage();
    //var result = '{"devTypeID":"2","deviceID":"53","deviceName":"SN_056566070","deviceUUID":"2LKZNE8XZ88BGD24111A","lngType":"zh","phoneType":"i","userId":"121","userName":"FMG","userToken":"5b18e39f-664c-4daa-906a-fca74bc8f9f7-241"}';
    var user = JSON.parse(result);

    var lang = "";
    if (user.lngType != "undefined" && "ch" == user.lngType) {
      lang = "cloud-zh";
    } else {
      lang = "cloud-en";
    }
    $translate.use(lang);

    $scope.refreshList = function(){
      $scope.getOrderList();
      $scope.$broadcast('scroll.refreshComplete');
    }
    $scope.editClick = function(){
      $scope.isEdit = !$scope.isEdit;
    }
    $scope.selectButton = function(userInfo){
      userInfo.select = !userInfo.select;
    }

    function dealHeader(url){
      var headersJson=myObj.getHeadersWithApi('/ppstrongs/'+url);
      var headers=JSON.parse(headersJson);
      $scope.authHeader = {
        'Content-Type': 'application/x-www-form-urlencoded',
        'X-Ca-Key':  headers.X_Ca_Key,
        'X-Ca-Sign':  headers.X_Ca_Sign,
        'X-Ca-Timestamp':  headers.X_Ca_Timestamp,
        'X-Ca-Nonce':  headers.X_Ca_Nonce
      }
    }
    $scope.getOrderList = function(){
      var param = {
        userID:user.userId,
        deviceID: user.deviceID,
        userToken : user.userToken,
        phoneType:user.phoneType,
        lngType:user.lngType,
        sourceApp:SourceApp
      }
      dealHeader('getOrderListInfos.action');

      $http({
        method: 'post',
        url: APIURL + 'getOrderListInfos.action',
        data:param,
        headers: $scope.authHeader,
        transformRequest: function (obj) {
          var str = [];
          for (var p in obj) {
            str.push(encodeURIComponent(p) + "=" + encodeURIComponent(obj[p]));
          }
          return str.join("&");
        }
      }).success(function (data, status, headers, config) {
        if ("1001" == data.resultCode) {
          dealData(data.orderList);
        } else if (data.resultCode == "1023") {
          myObj.showRepeatLogin();
        } else {
          myObj.error(angular.toJson(data));
        }
      }).error(function (data, status) {
        myObj.networkError();
      })
    }
    $scope.foodNum = 1;
    $scope.orderList = [];
    function dealData (data){
      $scope.orderList = [];
      for(var i=0;i<data.length;i++){
        var orderInfo = {
          select: false,
          mealType: data[i].mealType == "Y"? 'YEAR':data[i].serverTime >1 ?'MONTHS':'MONTH',
          payMoney: data[i].payMoney,
          storageType: data[i].storageTime == 7 ? 'SEVEN_DAY_BUTTON':'THIRTY_DAY_BUTTON',
          orderTime: formTime(data[i].createDate),
          endTime: formTime(data[i].serverEndTime),
          orderStatus: 2,
          serverTime: data[i].serverTime,
          orderNumber: data[i].orderNum,
        }
        $scope.orderList.push(orderInfo);
        console.log(orderInfo);
      }
    }

    // 暂时没有用
    $scope.deleteOrder = function(){
      for(var i=0;i<$scope.orderList.length;i++){
        if($scope.orderList[i].select){
          console.log($scope.orderList[i].orderNumber);
          $scope.orderList.splice(i,1);
          if($scope.orderList.length == 0)
            $scope.editClick();
        }
      }
      var dataStr = "&userID=" + user.userId + "&deviceID=" + user.deviceID + "&userToken=" + user.userToken;
      $http.jsonp(APIURL + 'getOrderListInfo.action?'+CallBack + dataStr +$scope.CommonParams)
        .success(function (data, status,headers,config) {
          if ("1001" == data.resultCode) {
            dealData(data.orderList);
          } else if (data.resultCode == "1023") {
            myObj.showRepeatLogin();
          } else {
            myObj.error(data.resultCode);
          }
        })
        .error(function (data, status,headers,config) {
          myObj.networkError();
        });
    }
    function formTime (date){
      var createDate = new Date(date);
      if (user.lngType != "undefined" &&"en" == user.lngType) {
        $scope.formDate = 'dd/MM/yyyy'
        return createDate;
      } else {
        $scope.formDate = 'yyyy.MM.dd'
        return createDate;
      }
    }

  }
  ctrl.$inject = ['$scope', '$http', '$ionicLoading', '$translate'];
  app.registerController('orderCtrl',ctrl);
});
