/**
 * Created by PPStrong on 16/12/5.
 */
define(['app'], function(app){
  'use strict';
  function ctrl($http,$scope,$translate,$ionicHistory,$ionicLoading,$timeout){
    var result = myObj.getMessage();
    var user = JSON.parse(result);
    var lang = "";
    if (user.lngType != "undefined" && "ch" == user.lngType  ) {
      lang = "personal-zh";
    } else {
    lang = "personal-en";
    }
    $translate.use(lang);

    $scope.userInfo = {
      name:user.nickname
    }
    function dealHeader(url){
      var headersJson=myObj.getHeadersWithApi('/ppstrongs/'+url);
      var headers=JSON.parse(headersJson);
      $scope.authHeader = {
        'Content-Type': 'application/x-www-form-urlencoded',
        'X-Ca-Key':  headers.X_Ca_Key,
        'X-Ca-Sign':  headers.X_Ca_Sign,
        'X-Ca-Timestamp':  headers.X_Ca_Timestamp,
        'X-Ca-Nonce':  headers.X_Ca_Nonce
      }
    }
    $scope.showPop = function(title){
      var showTitle = $translate.instant(title);
      myObj.showStatus(showTitle);
      $timeout(function(){
        $ionicHistory.goBack();
      },1000);
    }
    function onlyShowPop(title){
      var showTitle = $translate.instant(title);
      myObj.showStatus(showTitle);
    }
    $scope.changeName = function(){
      if($scope.userInfo.name.length == 0) {
        onlyShowPop('NAME_NOT_NULL');
        return;
      };

      myObj.showLoading();
      var param = {
        userID:user.userID,
        nickName: $scope.userInfo.name,
        userToken:user.userToken,
        phoneType:user.phoneType,
        lngType:user.lngType,
        sourceApp:SourceApp
      }
      dealHeader('updateNickName.action');
      $http({
        method: 'post',
        url: APIURL + 'updateNickName.action',
        data:param,
        headers: $scope.authHeader,
        transformRequest: function (obj) {
          var str = [];
          for (var p in obj) {
            str.push(encodeURIComponent(p) + "=" + encodeURIComponent(obj[p]));
          }
          return str.join("&");
        }
      }).success(function (data, status, headers, config) {

        if (data.resultCode == "1001") {
          myObj.saveNickname($scope.userInfo.name);
          $scope.showPop('CHANGE_SUCCESS');
        } else if (data.resultCode == "1023") {
          myObj.showRepeatLogin();
        } else {
          myObj.error(angular.toJson(data));
        }
      }).error(function (data, status) {
        myObj.networkError();
      })
    }
  }
  ctrl.$inject = ['$http','$scope','$translate','$ionicHistory','$ionicLoading','$timeout'];
  app.registerController('personalChangeNameCtrl', ctrl);
})
