/**
 * Created by PPStrong on 16/12/5.
 */
define(['app'], function(app){
  'use strict';
  function ctrl($scope,$http,$ionicLoading,$interval,$translate,$ionicHistory,$timeout) {

    var result = myObj.getMessage();
    var userInfo = JSON.parse(result);
    var lang = "";
    if ("ch" == userInfo.lngType) {
      lang = "personal-zh";
    } else {
      lang = "personal-en";
    }
    $translate.use(lang);

    // web
    //var userToken = "123";

    $scope.user = {
      account: userInfo.account,
      password:'',
      verCode:''
    }
    $scope.buttonDisabled =false;

    $scope.showPassword = function() {
      $scope.showPsd = !$scope.showPsd;
    }

    function dealHeader(url){
      var headersJson=myObj.getHeadersWithApi('/ppstrongs/'+url);
      var headers=JSON.parse(headersJson);
      $scope.authHeader = {
        'Content-Type': 'application/x-www-form-urlencoded',
        'X-Ca-Key':  headers.X_Ca_Key,
        'X-Ca-Sign':  headers.X_Ca_Sign,
        'X-Ca-Timestamp':  headers.X_Ca_Timestamp,
        'X-Ca-Nonce':  headers.X_Ca_Nonce
      }
    }
    $scope.showPop = function(title){
      var showTitle = $translate.instant(title);
      myObj.showStatus(showTitle);
     $timeout(function(){
        $ionicHistory.goBack();
      },1000);
    }
    function onlyShowPop(title){
      var showTitle = $translate.instant(title);
      myObj.showStatus(showTitle);
    }
    $scope.getVerCode = function(){
      // native
      var param = {
        userAccount:$scope.user.account,
        userToken:userInfo.userToken,
        phoneType:userInfo.phoneType,
        lngType:userInfo.lngType,
        sourceApp:SourceApp
      }
      dealHeader('getEmailVerifaction.action');
      //ajax请求
      myObj.showLoading();
      $http({
        method: 'post',
        url: APIURL + 'getEmailVerifaction.action',
        data:param,
        headers: $scope.authHeader,
        transformRequest: function (obj) {
          var str = [];
          for (var p in obj) {
            str.push(encodeURIComponent(p) + "=" + encodeURIComponent(obj[p]));
          }
          return str.join("&");
        }
      }).success(function (data, status, headers, config) {
        if (data.resultCode == "1001") {
          myObj.hideLoading();
          $scope.secondTimer(data.eTime);
        } else if (data.resultCode == "1023") {
          myObj.showRepeatLogin();
        } else if (data.resultCode == "1004") {
          onlyShowPop('VERCODE_SENDED');
          $scope.secondTimer(data.leastTime);
        } else {
          myObj.error(angular.toJson(data));
        }
      }).error(function (data, status) {
          myObj.networkError();
      })
    }

    $scope.secondTimer = function(num){
      if(!num || num == "undefined")return;
      var iNow = num;
      $scope.buttonDisabled =true;
      $scope.time=iNow;
      var timer = $interval(function(){
        $scope.time = iNow--;
        if (iNow == 0){
          $interval.cancel(timer);
          $scope.buttonDisabled = false;
        }
      },1000)
    }

    $scope.resetPassword = function(){
      if ($scope.user.account == '') {
        onlyShowPop('ACCOUNT_NULL');
        return;
      }
        if ($scope.user.verCode == '') {
            onlyShowPop('CODE_NOT_NULL');
            return;
        }
      if ($scope.user.password == '' || $scope.user.rePassword == '') {
        onlyShowPop('PSW_NULL');
        return;
      }
      if ($scope.user.password.length < 6 || $scope.user.password.length > 20) {
        onlyShowPop('PSW_LENGTH_ERROR');
        return;
      }

      if ($scope.user.password != $scope.user.rePassword) {
        onlyShowPop('PSW_NOT_SAME');
        return;
      }
      var desPsw = myObj.DESEncrypt($scope.user.password);
        myObj.showLoading();
      // native
      var param = {
        UserAccount:$scope.user.account,
        password:desPsw,
        verificationCode:$scope.user.verCode,
        userToken:userInfo.userToken,
        phoneType:userInfo.phoneType,
        lngType:userInfo.lngType,
        sourceApp:SourceApp
      }
      dealHeader('updatePassword.action');
      $http({
        method: 'post',
        url: APIURL + 'updatePassword.action',
        data:param,
        headers: $scope.authHeader,
        transformRequest: function (obj) {
          var str = [];
          for (var p in obj) {
            str.push(encodeURIComponent(p) + "=" + encodeURIComponent(obj[p]));
          }
          return str.join("&");
        }
      }).success(function (data, status, headers, config) {
        console.log(data);
        if (data.resultCode == "1001") {
          // 保存登录信息，并跳转到camera
          myObj.saveUserInfo(angular.toJson(data));
          $scope.showPop('CAHANGE_SUCCESS');
        } else if (data.resultCode == "1023") {
          myObj.showRepeatLogin();
        } else {
          myObj.error(angular.toJson(data));
        }
      }).error(function (data, status) {
          myObj.networkError();
      })
    }
  }
  ctrl.$inject = ['$scope','$http','$ionicLoading','$interval','$translate','$ionicHistory','$timeout'];
  app.registerController('personalChangePswCtrl', ctrl);
})
