/**
 * Created by PPStrong on 16/12/2.
 */

define(['app'], function(app){
  'use strict';
  function ctrl($scope,$state,$translate,$ionicLoading,$http,$ionicActionSheet,$timeout,$ionicPopup,storage){
    $scope.$on('$ionicView.enter',function(){
      $scope.refreshList();
      myObj.webViewDidFinishLoad();
    })
    $scope.$on('$ionicView.loaded',function(){
      setup();
    })

    function setup(){
      var result = myObj.getMessage();
      $scope.user = JSON.parse(result);
      var lang = "";
      if ($scope.user.lngType != "undefined" && "ch" == $scope.user.lngType  ) {
        lang = "personal-zh";
      } else {
        lang = "personal-en";
      }
      $translate.use(lang);

      $scope.userInfo = {
        userID: $scope.user.userID,
        imageUrl: $scope.user.imageUrl,
        account: $scope.user.account,
        nickName: $scope.user.nickname
      }
    }
    APIURL = storage.get('isTest') == 0 || typeof(storage.get('isTest')) == "undefined" ? formalUrl_https:testUrl_https;

    // 下拉刷新
    $scope.refreshList = function () {
      setup();
      $scope.$broadcast('scroll.refreshComplete');
    }
    $scope.editHead = function (){
      myObj.openEditHead();
    }
    $scope.changePassword = function(){
      $state.go('personalChangePsw');
    }
    $scope.changeNickName = function(){
      $state.go('personalChangeName');
    }
    function dealHeader(url) {
      var headersJson = myObj.getHeadersWithApi('/ppstrongs/' + url);
      var headers = JSON.parse(headersJson);
      $scope.authHeader = {
        'Content-Type': 'application/x-www-form-urlencoded',
        'X-Ca-Key': headers.X_Ca_Key,
        'X-Ca-Sign': headers.X_Ca_Sign,
        'X-Ca-Timestamp': headers.X_Ca_Timestamp,
        'X-Ca-Nonce': headers.X_Ca_Nonce
      }
    }

    // 退出账号
    $scope.logOut = function() {
      var title = $translate.instant('LOG_OUT_POP_TITLE');
      var ok = $translate.instant('OK');
      var cancel = $translate.instant('CANCEL');
      $ionicPopup.confirm({
        title: title,
        template:'<label style="text-align:center;width: 100%;display:inline-block;color: #9a9a9a;vertical-align: top" translate="LOG_OUT_POP_TEMP"></label>',
        cancelType: 'button-cancel',
        cancelText:cancel,
        okType: 'button-ok',
        okText: ok,
      }).then(function (res) {
        if (res) {
          logOutAction();
        } else {
          console.log('取消');
        }
      });
    }
    function logOutAction(){
      var param = {
        userID:$scope.user.userID,
        userToken:$scope.user.userToken,
        phoneType:$scope.user.phoneType,
        lngType:$scope.user.lngType,
        sourceApp:SourceApp
      }
      dealHeader('logOut.action');
      myObj.showLoading();
      $http({
        method: 'post',
        url: APIURL + 'logOut.action',
        data:param,
        headers: $scope.authHeader,
        transformRequest: function (obj) {
          var str = [];
          for (var p in obj) {
            str.push(encodeURIComponent(p) + "=" + encodeURIComponent(obj[p]));
          }
          return str.join("&");
        }
      }).success(function (data, status, headers, config) {
        if (data.resultCode == "1001") {
          myObj.hideLoading();
          myObj.gotoDestCtrl(angular.toJson(data));
        } else if (data.resultCode == "1023") {
          myObj.showRepeatLogin();
        } else {
          myObj.error(angular.toJson(data));
        }
      }).error(function (data, status) {
        myObj.networkError();
      })
    }
    $scope.backNative = function () {
      myObj.onBackClick();
    }
  }
  ctrl.$inject = ['$scope','$state','$translate','$ionicLoading','$http','$ionicActionSheet','$timeout','$ionicPopup','storage'];
  app.registerController('personalInfoCtrl', ctrl);
});
